quest snow_dungeon begin
	state start begin
		function settings()
			local settings = {}
			settings.map_index = 352
			settings.base_cords = {5120, 1536}
			settings.outside_cords = {61, 4326, 1655}
			settings.floor1_start_position = {171, 278}
			settings.floor2_start_position = {420, 261}
			settings.floor3_start_position = {762, 263}
			settings.floor4_start_position = {173, 535}
			settings.floor5_start_position = {420, 537}
			settings.floor6_start_position = {746, 540}
			settings.floor7_start_position = {302, 708}
			settings.floor8_start_position = {568, 701}
			settings.floor9_start_position = {849, 693}
			settings.floor10_start_position = {927, 389}
			settings.required_level = 100
			settings.dungeon_time = 60*60*1
			settings.dungeon_cooldown = 60*30
			settings.party_rejoin_time = 60*5
			settings.floor_check_delay = 5
			settings.notice_remaining_time = 60*15
			settings.floor_jump_delay = 5
			settings.floor_jump_all_out_delay = 60*1
			settings.cubes = 5
			settings.cubes_penalty = false
			settings.skip_cubes = false
			settings.floor2_key = 30331
			settings.floor5_key = 30332
			settings.floor8_key = 30333
			settings.cube = 20398
			settings.szel = 6151
			settings.nemere = 6191
			settings.metin = 8058
			settings.pilar = 20399
			settings.guardian = 20395
			settings.lion = 20397
			settings.floor1_lion_position = {172, 261}
			settings.floor9_lion_position = {849, 641}
			settings.floor4_szel_cords = {{160, 490}, {215, 440}, {140, 425}}
			settings.floor7_szel_cords = {{302, 642}, {324, 651}, {299, 679}, {287, 670}, {273, 657}}
			settings.floor5_cube_cords = {{391, 490}, {451, 490}, {463, 455}, {380, 456}, {420, 422}}
			settings.floor6_metin_cords = {747, 494}
			settings.floor9_pilar_cords = {849, 655}
			settings.floor10_nemere_cords = {928, 335}
			return settings
		end

		function is_nemere_dungeon()
			local settings = snow_dungeon.settings()
			local map_index = pc.get_map_index()
			if map_index >= (settings.map_index * 10000) and map_index < (settings.map_index * 10000 + 9000) then
				return true
			else
				return false
			end
		end

		when login begin
			if snow_dungeon.is_nemere_dungeon() then
				pc.set_warp_location(settings.outside_cords[1], settings.outside_cords[2], settings.outside_cords[3])
				if d.getf("party_leader_pid") != party.get_leader_pid() then
					d.exit()
					return
				end
				if pc.get_level() < settings.required_level then
					d.exit()
					return
				end
			end
		end

		when logout begin
			if snow_dungeon.is_nemere_dungeon() then
				local settings = snow_dungeon.settings()
				pc.setqf("out_party_time", get_global_time() + settings.party_rejoin_time)
			end
		end

		when 20395.chat.gameforge.snow_dungeon._say_npc begin
			local settings = snow_dungeon.settings()
			say_npc()
			if party.is_party() then
				if d.find(party.getf("snow_dungeon_map_index")) then
					if pc.getqf("out_party_time") < get_global_time() then
						say(gameforge.snow_dungeon._need_group)
						return
					end
					local floor = d.getf_from_map_index("floor", party.getf("snow_dungeon_map_index"))
					local warp_to_floor = settings.floor1_start_position
					if floor >= 1 and floor <= 10 then
						if floor == 1 then warp_to_floor = settings.floor1_start_position
						elseif floor == 2 then warp_to_floor = settings.floor2_start_position
						elseif floor == 3 then warp_to_floor = settings.floor3_start_position
						elseif floor == 4 then warp_to_floor = settings.floor4_start_position
						elseif floor == 5 then warp_to_floor = settings.floor5_start_position
						elseif floor == 6 then warp_to_floor = settings.floor6_start_position
						elseif floor == 7 then warp_to_floor = settings.floor7_start_position
						elseif floor == 8 then warp_to_floor = settings.floor8_start_position
						elseif floor == 9 then warp_to_floor = settings.floor9_start_position
						elseif floor == 10 then warp_to_floor = settings.floor10_start_position
						end
						pc.warp((settings.base_cords[1] + warp_to_floor[1])*100, (settings.base_cords[2] + warp_to_floor[2])*100, party.getf("snow_dungeon_map_index"))
					else
						return
					end
				end

				if (pc.is_gm() and pc.getf("snow_dungeon", "duration") >= get_global_time()) then
					say("")
					say_title(gameforge.snow_dungeon._gm)
					say(gameforge.snow_dungeon._reset_time)
					say("")
					say_reward("Temps restant: "..LIB_duration(pc.getf("snow_dungeon", "duration") - get_global_time()).."")
					if select(gameforge.snow_dungeon._yes, gameforge.snow_dungeon._no) == 1 then
						pc.setf("snow_dungeon", "duration", 0)
						return
					end
				elseif pc.getf("snow_dungeon", "duration") >= get_global_time() then
					say(gameforge.snow_dungeon._already_done)
					say("")
					say_reward("Temps restant: "..LIB_duration(pc.getf("snow_dungeon", "duration") - get_global_time()).."")
					return
				end
				if party.is_leader() then
					if snow_dungeon.check_members() == false then
						return
					end
					say(gameforge.snow_dungeon._enter_dungeon)
					if select(gameforge.snow_dungeon._yes, gameforge.snow_dungeon._no) == 1 then
						snow_dungeon.make()
					end
				else
					say(gameforge.snow_dungeon._only_leader)
				end
			else
				say(gameforge.snow_dungeon._no_group)
			end
		end

		function check_members()
			local settings = snow_dungeon.settings()
			local pids = {party.get_member_pids()}
			local unqualified_members = {}
			local repeated_members = {}
			local has_ninja_members = false
			local has_shaman_members = false

			for index = 1, table.getn(pids), 1 do
				q.begin_other_pc_block(pids[index])
				if pc.get_level() < settings.required_level then
					table.insert(unqualified_members, table.getn(unqualified_members)+1, pc.get_name())
				end
				if pc.getf("snow_dungeon", "duration") >= get_global_time() then
					table.insert(repeated_members, table.getn(repeated_members)+1, pc.get_name())
				end
				if pc.get_job() == 1 or pc.get_job() == 5 then
					has_ninja_members = true
				end
				if pc.get_job() == 3 or pc.get_job() == 7 then
					has_shaman_members = true
				end
				q.end_other_pc_block()
			end
			if table.getn(unqualified_members) >= 1 then
				say(gameforge.snow_dungeon._say_no_quality)
				say("")
				say_reward(gameforge.snow_dungeon._say_no_level)
				for index = 1, table.getn(unqualified_members), 1 do
					say(color(1,1,0), "	"..unqualified_members[index])
				end
				return false
			end
			if table.getn(repeated_members) >= 1 then
				say(gameforge.snow_dungeon._say_no_quality)
				say("")
				say_reward(gameforge.snow_dungeon._say_already_done)
				for index = 1, table.getn(repeated_members), 1 do
					say(color(1,1,0), "	"..repeated_members[index])
				end
				return false
			end
			if has_ninja_members == false then
				say(gameforge.snow_dungeon._need_ninja)
				return false
			end
			if has_shaman_members == false then
				say(gameforge.snow_dungeon._need_shaman)
				return false
			end
		end

		function make()
			local settings = snow_dungeon.settings()
			d.new_jump_party(settings.map_index, (settings.base_cords[1] + settings.floor1_start_position[1]), (settings.base_cords[2] + settings.floor1_start_position[2]))
			snow_dungeon.clear()
			d.setf("party_leader_pid", party.get_leader_pid())
			party.setf("snow_dungeon_map_index", d.get_map_index())
			d.spawn_mob_dir(settings.lion, settings.floor1_lion_position[1], settings.floor1_lion_position[2], 1)
		end

		function clear()
			local map_index = d.get_map_index()
			clear_server_timer("floor_check_delay", map_index)
			clear_server_timer("jump_floor1", map_index)
			clear_server_timer("jump_floor2", map_index)
			clear_server_timer("jump_floor3", map_index)
			clear_server_timer("jump_floor4", map_index)
			clear_server_timer("jump_floor5", map_index)
			clear_server_timer("jump_floor6", map_index)
			clear_server_timer("jump_floor7", map_index)
			clear_server_timer("jump_floor8", map_index)
			clear_server_timer("jump_floor9", map_index)
			clear_server_timer("jump_floor10", map_index)
			clear_server_timer("jump_all_out", map_index)
			clear_server_timer("finish_time", map_index)
			clear_server_timer("notice_remaining_time", map_index)
			d.setf("party_leader_pid", 0)
			d.setf("floor", 0)
			d.setf("start_time", 0)
			d.setf("notice_time", 0)
			d.setf("floor5_cube", 0)
			for szel = 1, 5 do
				d.setf("floor7_dead_szel_"..szel, 0)
			end
			d.setf("floor2_is_key", 0)
			d.setf("floor8_is_key", 0)
			snow_dungeon.clear_floor()
		end

		function clear_floor()
			d.clear_regen()
			d.kill_all()
		end

		when 20397.chat.gameforge.snow_dungeon.start_dungeon with snow_dungeon.is_nemere_dungeon() and d.getf("floor") == 0 begin
			local settings = snow_dungeon.settings()
			say(gameforge.snow_dungeon._lion_say_01)
			npc.purge()
			d.setf("floor", 1)
			d.regen_file("data/dungeon/snow_dungeon/id_1f.txt")
			d.notice(gameforge.snow_dungeon._killall_mobs) 

			d.setf("notice_time", 1)
			d.setf("start_time", get_global_time() + settings.dungeon_time)
			d.setqf2("snow_dungeon", "duration", get_global_time() + settings.dungeon_cooldown)
			server_timer("finish_time", (get_global_time() + settings.dungeon_time) - get_global_time(), d.get_map_index())
			server_loop_timer("floor_check_delay", settings.floor_check_delay, d.get_map_index())
			server_loop_timer("notice_remaining_time", settings.notice_remaining_time, d.get_map_index())
		end

		when floor_check_delay.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				local floor = d.getf("floor")
				if floor == 1 and d.count_monster() <= 0 then
					snow_dungeon.clear_floor()
					d.notice(gameforge.snow_dungeon._teleport_second_step)
					server_timer("jump_floor2", settings.floor_jump_delay, d.get_map_index())
					d.set_regen_file("data/dungeon/snow_dungeon/id_2f.txt")
				elseif floor == 3 and d.count_monster() <= 0 then
					snow_dungeon.clear_floor()
					d.notice(gameforge.snow_dungeon._teleport_second_step)
					server_timer("jump_floor4", settings.floor_jump_delay, d.get_map_index())
					d.regen_file("data/dungeon/snow_dungeon/id_4f.txt")
				elseif floor == 4 and d.count_monster() <= 0 then
					snow_dungeon.clear_floor()
					d.regen_file("data/dungeon/snow_dungeon/id_4f.txt")
					local random_spawn = number(1, table.getn(settings.floor4_szel_cords))
					d.spawn_mob(settings.szel, settings.floor4_szel_cords[random_spawn][1], settings.floor4_szel_cords[random_spawn][2])
				elseif floor == 6 and d.count_monster() <= 0 then
					snow_dungeon.clear_floor()
					d.spawn_mob(settings.metin, settings.floor6_metin_cords[1], settings.floor6_metin_cords[2])
				elseif floor == 7 then
					if not d.is_unique_dead("floor7_szel_5") then
						for szel = 1, 4 do
							if d.getf("floor7_dead_szel_"..szel) == 0 then
								if d.unique_get_hp_perc("floor7_szel_"..szel) < 50 then
									d.purge_unique("floor7_szel_"..szel)
									d.setf("floor7_dead_szel_"..szel, 1)
									d.notice(gameforge.snow_dungeon._szel_double)
								end
							end
						end
					else
						return
					end
				end
			end
		end

		when jump_floor2.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 2)
				d.jump_all((settings.base_cords[1] + settings.floor2_start_position[1]), (settings.base_cords[2] + settings.floor2_start_position[2]))
				d.notice(gameforge.snow_dungeon._drop_key01)
				d.notice(gameforge.snow_dungeon._only_shaman)
			end
		end

		when jump_floor3.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 3)
				d.jump_all((settings.base_cords[1] + settings.floor3_start_position[1]), (settings.base_cords[2] + settings.floor3_start_position[2]))
				d.notice(gameforge.snow_dungeon._killall_mobs)
			end
		end

		when jump_floor4.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 4)
				d.jump_all((settings.base_cords[1] + settings.floor4_start_position[1]), (settings.base_cords[2] + settings.floor4_start_position[2]))
				d.notice(gameforge.snow_dungeon._killall_mobs02)
			end
		end

		when jump_floor5.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 5)
				d.jump_all((settings.base_cords[1] + settings.floor5_start_position[1]), (settings.base_cords[2] + settings.floor5_start_position[2]))
				d.notice(gameforge.snow_dungeon._open_all_cube)
				d.notice(gameforge.snow_dungeon._drop_key02)
			end
		end

		when jump_floor6.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 6)
				d.jump_all((settings.base_cords[1] + settings.floor6_start_position[1]), (settings.base_cords[2] + settings.floor6_start_position[2]))
				d.notice(gameforge.snow_dungeon._destroy_stone01)
			end
		end

		when jump_floor7.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 7)
				d.jump_all((settings.base_cords[1] + settings.floor7_start_position[1]), (settings.base_cords[2] + settings.floor7_start_position[2]))
				d.notice(gameforge.snow_dungeon._kill_szel_boss)
			end
		end

		when jump_floor8.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 8)
				d.jump_all((settings.base_cords[1] + settings.floor8_start_position[1]), (settings.base_cords[2] + settings.floor8_start_position[2]))
				d.notice(gameforge.snow_dungeon._drop_key03)
				d.notice(gameforge.snow_dungeon._only_ninja)
			end
		end

		when jump_floor9.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 9)
				d.jump_all((settings.base_cords[1] + settings.floor9_start_position[1]), (settings.base_cords[2] + settings.floor9_start_position[2]))
				d.notice(gameforge.snow_dungeon._destroy_stone02)
				d.notice(gameforge.snow_dungeon._only_ninja_and_shaman)
			end
		end

		when jump_floor10.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.setf("floor", 10)
				d.jump_all((settings.base_cords[1] + settings.floor10_start_position[1]), (settings.base_cords[2] + settings.floor10_start_position[2]))
				d.notice(gameforge.snow_dungeon._kill_the_boss)
			end
		end

		function check_time()
			local remaining_time = d.getf("start_time") - get_global_time()
			if d.getf("notice_time") == 1 then
				d.notice("Temps restant  l'Observatoire Nmre: "..math.ceil(remaining_time/60).." minute(s)")
				d.notice(gameforge.snow_dungeon._time_remaining_alert)
			else
				d.setf("notice_time", 1)
			end
		end

		when notice_remaining_time.server_timer begin
			if d.select(get_server_timer_arg()) then
				snow_dungeon.check_time()
			end
		end

		when 30331.use with snow_dungeon.is_nemere_dungeon() begin
			local settings = snow_dungeon.settings()
			local floor = d.getf("floor")
			if floor == 2 then
				if pc.get_job() == 3 or pc.get_job() == 7 then
					if d.getf("floor2_is_key") == 1 then
						return
					else
						if number(1, 3) == 1 then
							d.setf("floor2_is_key", 1)
							item.remove()
							snow_dungeon.clear_floor()
							d.notice(gameforge.snow_dungeon._teleport_alert)
							server_timer("jump_floor3", settings.floor_jump_delay, d.get_map_index())
							d.regen_file("data/dungeon/snow_dungeon/id_3f.txt")
						else
							d.setf("floor2_is_key", 0)
							item.remove()
							syschat(gameforge.snow_dungeon._wrong_key)
						end
					end
				else
					syschat(gameforge.snow_dungeon._only_shaman02)
					return
				end
			end
		end

		when 30333.use with snow_dungeon.is_nemere_dungeon() begin
			local settings = snow_dungeon.settings()
			local floor = d.getf("floor")
			if floor == 8 then
				if pc.get_job() == 1 or pc.get_job() == 5 or pc.get_job() == 3 or pc.get_job() == 7 then
					if d.getf("floor8_is_key") == 1 then
						return
					else
						if number(1, 3) == 1 then
							d.setf("floor8_is_key", 1)
							item.remove()
							snow_dungeon.clear_floor()
							d.notice(gameforge.snow_dungeon._teleport_alert)
							server_timer("jump_floor9", settings.floor_jump_delay, d.get_map_index())
							d.regen_file("data/dungeon/snow_dungeon/id_9f.txt")
							d.spawn_mob(settings.pilar, settings.floor9_pilar_cords[1], settings.floor9_pilar_cords[2])
						else
							d.setf("floor8_is_key", 0)
							item.remove()
							syschat(gameforge.snow_dungeon._wrong_key)
						end
					end
				else
					syschat(gameforge.snow_dungeon._only_ninja02)
					return
				end
			end
		end

		when 20397.chat.gameforge.snow_dungeon._enter_boss_room with snow_dungeon.is_nemere_dungeon() and d.getf("floor") == 9 begin
			local settings = snow_dungeon.settings()
			if party.is_party() then
				if party.is_leader() then
					say(gameforge.snow_dungeon._keep_continue)
					if select(gameforge.snow_dungeon._yes, gameforge.snow_dungeon._no) == 1 then
						npc.purge()
						server_timer("jump_floor10", settings.floor_jump_delay, d.get_map_index())
						snow_dungeon.clear_floor()
						d.regen_file("data/dungeon/snow_dungeon/id_boss.txt")
						d.spawn_mob(settings.nemere, settings.floor10_nemere_cords[1], settings.floor10_nemere_cords[2])
					end
				else
					say(gameforge.snow_dungeon._only_leader)
				end
			else
				say(gameforge.snow_dungeon._need_group)
			end
		end

		function floor5_create_cubes()
			local settings = snow_dungeon.settings()
			local order = {0, 0, 0, 0, 0}
			for cubes = 1, settings.cubes do
				local random = number(1, settings.cubes)
				local random_order = 0
				for random_cubes = 1, 50 do
					random_order = random_order+1
					if random_order > settings.cubes then
						random_order = 1
					end
					if order[random_order] == 0 then
						random = random-1
						if random == 0 then
							order[random_order] = 1
							d.set_unique("floor5_cube_"..random_order, d.spawn_mob(settings.cube, settings.floor5_cube_cords[cubes][1], settings.floor5_cube_cords[cubes][2]))
							break
						end
					end
				end
			end
		end

		function floor7_create_szels()
			local settings = snow_dungeon.settings()
			local order = {0, 0, 0, 0, 0}
			for szels = 1, 5 do
				local random = number(1, 5)
				local szel = 0
				for random_szels = 1, 50 do
					szel = szel+1
					if szel > 5 then
						szel = 1
					end
					if order[szel] == 0 then
						random = random-1
						if random == 0 then
							order[szel] = 1
							d.set_unique("floor7_szel_"..szel, d.spawn_mob(settings.szel, settings.floor7_szel_cords[szels][1], settings.floor7_szel_cords[szels][2]))
							break
						end
					end
				end
			end
		end

		when 20398.take with snow_dungeon.is_nemere_dungeon() begin
			local settings = snow_dungeon.settings()
			if item.get_vnum() == settings.floor5_key then
			local vid, order = npc.get_vid(), d.getf("floor5_cube")
			if vid == d.get_unique_vid("floor5_cube_1") then
				snow_dungeon.cube_take(0)
			elseif vid == d.get_unique_vid("floor5_cube_2") then
				snow_dungeon.cube_take(order == 2 and 2 or -1)
			elseif vid == d.get_unique_vid("floor5_cube_3") then
				snow_dungeon.cube_take(order == 3 and 3 or -1)
			elseif vid == d.get_unique_vid("floor5_cube_4") then
				snow_dungeon.cube_take(order == 4 and 4 or -1)
			else
				snow_dungeon.cube_take(order == 5 and 5 or -1)
			end
			item.remove()
			end
		end

		function cube_take(order)
			local settings = snow_dungeon.settings()
			if order == 0 then
				d.setf("floor5_cube", 2)
			elseif order == -1 then
				say(gameforge.snow_dungeon._not_good_order)
				if settings.cubes_penalty == true then
					d.regen_file("data/dungeon/snow_dungeon/id_5f.txt")
				end
				return
			elseif order == settings.cubes then
				snow_dungeon.clear_floor()
				npc.purge()
				d.notice(gameforge.snow_dungeon._teleport_alert)
				server_timer("jump_floor6", settings.floor_jump_delay, d.get_map_index())
				d.regen_file("data/dungeon/snow_dungeon/id_6f.txt")
				return
			else
				d.setf("floor5_cube", d.getf("floor5_cube")+1)
			end
			npc.purge()
		end

		when finish_time.server_timer begin
			if d.select(get_server_timer_arg()) then
				d.notice(gameforge.snow_dungeon._time_is_up)
				d.notice(gameforge.snow_dungeon._teleport_alert02)
				server_timer("jump_all_out", 1, d.get_map_index())
			end
		end

		when kill with snow_dungeon.is_nemere_dungeon() begin
			local settings = snow_dungeon.settings()
			local floor = d.getf("floor")

			if floor == 2 and npc.get_race() >= 6101 and npc.get_race() <= 6108 and 1 == number(1, 10) then
				game.drop_item(settings.floor2_key, 1)

			elseif floor == 4 and npc.get_race() == settings.szel then
				d.notice(gameforge.snow_dungeon._teleport_alert)
				if settings.skip_cubes == false then
					snow_dungeon.clear_floor()
					server_timer("jump_floor5", settings.floor_jump_delay, d.get_map_index())
					d.regen_file("data/dungeon/snow_dungeon/id_5f.txt")
					snow_dungeon.floor5_create_cubes()
				else
					snow_dungeon.clear_floor()
					server_timer("jump_floor6", settings.floor_jump_delay, d.get_map_index())
					d.regen_file("data/dungeon/snow_dungeon/id_6f.txt")
				end

			elseif floor == 5 and npc.get_race() >= 6101 and npc.get_race() <= 6108 and 1 == number(1, 15) then
				game.drop_item(settings.floor5_key, 1)

			elseif floor == 6 and npc.get_race() == settings.metin then
				snow_dungeon.clear_floor()
				d.notice(gameforge.snow_dungeon._teleport_alert)
				server_timer("jump_floor7", settings.floor_jump_delay, d.get_map_index())
				d.regen_file("data/dungeon/snow_dungeon/id_7f.txt")
				snow_dungeon.floor7_create_szels()

			elseif floor == 7 and npc.get_race() == settings.szel then
				if npc.get_vid() == d.get_unique_vid("floor7_szel_5") then
					snow_dungeon.clear_floor()
					d.notice(gameforge.snow_dungeon._teleport_alert)
					server_timer("jump_floor8", settings.floor_jump_delay, d.get_map_index())
					d.regen_file("data/dungeon/snow_dungeon/id_8f.txt")
				end

			elseif floor == 8 and npc.get_race() >= 6101 and npc.get_race() <= 6108 and 5 == number(1, 10) then
				if pc.get_job() == 1 or pc.get_job() == 5 then
					game.drop_item(settings.floor8_key, 1)
				end

			elseif floor == 9 and npc.get_race() == settings.pilar then
				snow_dungeon.clear_floor()
				d.spawn_mob_dir(settings.lion, settings.floor9_lion_position[1], settings.floor9_lion_position[2], 1)

			elseif floor == 10 and npc.get_race() == settings.nemere then
				snow_dungeon.clear_floor()
				d.notice(gameforge.snow_dungeon._boss_has_been_killed)
				d.notice(gameforge.snow_dungeon._teleport_alert02)
				notice_all("Flicitation au groupe de "..pc.get_name().." d'avoir vaincu le Seigneur Nmre")
				server_timer("jump_all_out", settings.floor_jump_all_out_delay, d.get_map_index())
			end
		end

		when jump_all_out.server_timer begin
			if d.select(get_server_timer_arg()) then
				local settings = snow_dungeon.settings()
				d.set_warp_location(settings.outside_cords[1], settings.outside_cords[2], settings.outside_cords[3])
				d.setf("party_leader_pid", 0)
				d.exit_all()
			end
		end
	end
end

