quest flame_dungeon begin
	state start begin   
		when 20394.click with pc.get_level() >= 100 begin
			pc.give_item2(71175, 1) -- Supprimer ceci pour que le gardien ne donne plus le ticket. (debug_mode)
			set_state(run)
		end
	end

	state run begin 
		function setting()
			return
			{
				["bossroom_entry_pos"] = {8109,6867},
				["boss_pos"] = {686,637},
				["doors_pos"] = {
					{320,394},
					{293,359},
					{333,321},
					{378,320},
					{400,355},
					{394,401}
				},
				["idoors_pos"] = {
					{268,447},
					{234,359},
					{300,264},
					{454,217},
					{470,355},
					{467,469}
				},
				["doors_dir"] = {135,90,210,152,90,223},
				["idoors_dir"] = {135,90,210,135,90,239},
				["dungeon_entry_pos"] = {7766, 6719},
				["DUNGEON_MAN_bpos"] = {690,722},
				["DUNGEON_MAN_pos"] = {354,362},
				["LEVEL2_STONE_pos"] = {195,352},
				["LEVEL4_TARGET_pos"] = {470,175},
				["LEVEL5_STONE_pos"] = {
					{486, 345},
					{511, 336},
					{525, 349},
					{521, 365},
					{503, 372},
					{486, 365},
					{500, 354}
				},
				["LEVEL6_TARGET_pos"] = {511,480},
				["outside_entry_pos"] = {5980,7075},
			}
		end
		
		function is_flamed(idx)
			return idx >= 351 * 10000 and idx < (351 + 1) *10000
		end

		function make_dungeon()
			local setting = flame_dungeon.setting()
			d.new_jump_party(351, setting.dungeon_entry_pos[1], setting.dungeon_entry_pos[2])
			d.regen_file("data/dungeon/flame_dungeon/npc.txt")
			d.setf("level",0)
			for i=1,6 do
				d.set_unique("door"..i, d.spawn_mob_ac_dir(20387, setting.doors_pos[i][1], setting.doors_pos[i][2],setting.doors_dir[i]))
			end
			for i=1,6 do
				d.set_unique("idoor"..i, d.spawn_mob_ac_dir(20388, setting.idoors_pos[i][1], setting.idoors_pos[i][2],setting.idoors_dir[i]))
			end
			d.setf("clear_count",0)
			d.setf("started",0)
			d.setf("dungeon_enter",0)
			d.setf("counter_11", 180)
			d.setf("counter_13", 180)
		end

		function go_boss()
			local setting = flame_dungeon.setting()
			if pc.get_level() < 100 then
				say(gameforge.flame_dungeon._say_10)
				return
			else
				local warp =  select(gameforge.flame_dungeon._say_enter, gameforge.flame_dungeon._say_no_enter)
				if warp == 1 then
					d.setf("level",17)
					d.jump_all(setting.bossroom_entry_pos[1],setting.bossroom_entry_pos[2])
					d.set_regen_file ("data/dungeon/flame_dungeon/".."fd_fild_boss.txt")
					d.spawn_mob(6091,setting.boss_pos[1],setting.boss_pos[2])
				end
			end
		end

		function level_clear()
			d.setf("level",0)
			d.clear_regen()
			d.purge_area(750000,620000,817400,689400)
		end

		function clear_timer(inx)
			clear_server_timer ("flame_dungeon_0m_left_timer", inx)
			clear_server_timer ("flame_dungeon_1m_left_timer", inx)
			clear_server_timer ("flame_dungeon_5m_left_timer", inx)
			clear_server_timer ("flame_dungeon_10m_left_timer", inx)
			clear_server_timer ("flame_dungeon_15m_left_timer", inx)
			clear_server_timer ("flame_dungeon_30m_left_timer", inx)
			clear_server_timer ("flame_dungeon_45m_left_timer", inx)
			clear_server_timer ("flame_dungeon_ticket_remove", inx) 
		end

		when login begin
			local idx = pc.get_map_index()
			local setting = flame_dungeon.setting()
			if idx == 351 then
			elseif flame_dungeon.is_flamed(idx) then
				local ticketGroup = {71175, 1}
				if d.getf("dungeon_enter") == 0 then
					local canPass = false
					for i=1, table.getn(ticketGroup),2 do
						if pc.count_item(ticketGroup[i]) >= ticketGroup[i+1] then
							canPass = true
							break
						end
					end

					if get_global_time() - pc.getf("flame_dungeon","exit_time") < 0 then
						notice_multiline("O tempo de espera ainda no terminou!",d.notice)
						say("O tempo de espera ainda no terminou!")
						timer("flame_dungeon_warp_timer", 5)
					elseif not canPass then
						notice_multiline("No podes entrar no Forte do Drago Vermelho sem um grupo.", d.notice)
						say("No podes entrar no Forte do Drago Vermelho sem um grupo.")
						timer("flame_dungeon_warp_timer", 5)
					elseif pc.get_level() < 100 then
						notice_multiline("Apenas jogadores experientes podem entrar[ENTER]no Forte do Drago Vermelho.",d.notice)
						say("Apenas jogadores experientes podem entrar[ENTER]no Forte do Drago Vermelho.")
						timer("flame_dungeon_warp_timer", 5)
					end
					elseif pc.getf("flame_dungeon","ticket_delete") == 0 then

					for i=1, table.getn(ticketGroup),2 do
						if pc.count_item(ticketGroup[i]) >= ticketGroup[i+1] then
							pc.remove_item(ticketGroup[i], ticketGroup[i+1])
							break
						end
					end
					pc.setf("flame_dungeon","ticket_delete", 1)
				end
			else
				pc.setf("flame_dungeon","ticket_delete", 0)
			end
		end

		when flame_dungeon_warp_timer.timer begin
			local setting = flame_dungeon.setting()
			pc.warp(setting.outside_entry_pos[1]*100, setting.outside_entry_pos[2] * 100, 62)
		end

		when logout begin
			local idx = pc.get_map_index()
			if flame_dungeon.is_flamed(idx) then 
				if d.getf("dungeon_enter") == 1 then
					pc.setf("flame_dungeon","exit_time",get_global_time())
				end
			end
		end

		when 20394.chat.gameforge.flame_dungeon._say_npc begin
			local setting = flame_dungeon.setting()
			if party.is_party() then
				local party_check = 0
				if d.find(party.getf("dungeon_index")) then
					party_check = (d.getf_from_map_index("party_leader_pid", party.getf("dungeon_index")) == party.get_leader_pid())
				end

				if d.find(party.getf("dungeon_index")) and party_check then
					if get_global_time() - pc.getf("flame_dungeon","exit_time") < 5 * 60 then
						local dungeon_level = d.getf_from_map_index("level", party.getf("dungeon_index"))
						if dungeon_level == 17 then
							pc.warp(setting.bossroom_entry_pos[1] * 100, setting.bossroom_entry_pos[2] * 100, party.getf("dungeon_index"))
						else
							pc.warp(setting.dungeon_entry_pos[1] * 100, setting.dungeon_entry_pos[2] * 100, party.getf("dungeon_index"))
						end
					else
						say_title(mob_name(20394))
						say(gameforge.flame_dungeon._cant_enter_now)
					end
				else
					local pids = {party.get_member_pids()}
					local noTicketMembers = {}
					local notEnoughLevelMembers = {}
					local ticketCheck = true
					local levelCheck = true
					local ticketGroup = {71175, 1}
					for i, pid in next, pids, nil do
						q.begin_other_pc_block(pid)
						local canPass = false
						for idx=1, table.getn(ticketGroup),2 do
							if pc.count_item(ticketGroup[idx]) >= ticketGroup[idx+1] then
								canPass = true
								break
							end
						end

						if not canPass then
							table.insert(noTicketMembers, pc.get_name())
							ticketCheck = false
						end
						if pc.level < 100 then
							table.insert(notEnoughLevelMembers, pc.get_name())
							levelCheck = false
						end
						q.end_other_pc_block()
					end

					if not ticketCheck then
						say_title(mob_name(20394))
						say(gameforge.flame_dungeon._say_no_quality)
						say("")
						say_reward(gameforge.flame_dungeon._say_no_ticket)

						for i, name in next, noTicketMembers, nil do
							say(color(1,1,0), " "..name)
						end
						if levelCheck then
							return
						else
							wait()
						end
					end

					if not levelCheck then
						say_title(mob_name(20394))
						say(gameforge.flame_dungeon._say_no_quality)
						say("")
						say_reward(gameforge.flame_dungeon._say_no_level)
						for i, name in next, notEnoughLevelMembers, nil do
							say(color(1,1,0), " "..name)
						end
						return
					end

					if party.is_leader() then
						say_npc()
						say(gameforge.flame_dungeon._say_want_enter)

						local warp =  select(gameforge.flame_dungeon._say_enter, gameforge.flame_dungeon._say_no_enter)
						if warp == 1 then
							if party.is_map_member_flag_lt("exit_time", get_global_time() - 0 ) then
								flame_dungeon.make_dungeon()
							else
								say(gameforge.flame_dungeon._say_time_alway_on)
							end
						end
						party.setf("flame_dungeon_boss_kill_count", 0)
					else
						say_npc()
						say(gameforge.flame_dungeon._say_your_not_leader)
					end
				end
			else
				say_title(mob_name(20394))
				say(gameforge.flame_dungeon._say_no_group)
			end
		end

		when flame_dungeon_45m_left_timer.timer begin
			notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 45), d.notice)
			notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)
			timer("flame_dungeon_30m_left_timer", 15*60)
		end

		when flame_dungeon_30m_left_timer.timer begin
			notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 30), d.notice)
			notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)
			timer("flame_dungeon_15m_left_timer", 15*60)
		end

		when flame_dungeon_15m_left_timer.timer begin
			notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 15), d.notice)
			notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)
			timer("flame_dungeon_5m_left_timer", 10*60)
		end

		when flame_dungeon_5m_left_timer.timer begin
			notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 5), d.notice)
			notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)
			timer("flame_dungeon_1m_left_timer", 4*60)
		end

		when flame_dungeon_1m_left_timer.timer begin
			notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 1), d.notice)
			notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)
			timer("flame_dungeon_0m_left_timer", 60)
		end

		when flame_dungeon_0m_left_timer.timer begin
			local setting = flame_dungeon.setting()
			notice_multiline(gameforge.flame_dungeon._time_is_up, d.notice)
			notice_multiline(gameforge.flame_dungeon._group_teleport, d.notice)
			timer("exit_dungeon",10)
		end

		when 20385.chat.gameforge.flame_dungeon._say_npc2 with npc.lock() begin
			local setting = flame_dungeon.setting()
			if d.getf("started") == 0 then
				say(gameforge.flame_dungeon._npc2_say01)
				wait()
				d.setf("started",1)
				timer("flame_dungeon_45m_left_timer",15*60)
				notice_multiline(string.format(gameforge.flame_dungeon._time_remaining, 60), d.notice)
				notice_multiline(gameforge.flame_dungeon._time_remaining_alert, d.notice)

				local pids = {party.get_member_pids()}
				local ticketGroup = {71175, 1}
				for i, pid in next, pids, nil do
					q.begin_other_pc_block(pid)
					local canPass = false
					for idx=1, table.getn(ticketGroup),2 do
						if pc.count_item(ticketGroup[idx]) >= ticketGroup[idx+1] then
							canPass = true
							pc.remove_item(ticketGroup[idx], ticketGroup[idx+1])
							break
						end
					end
					
					if not canPass then
						pc.warp(setting.outside_entry_pos[1]*100, setting.outside_entry_pos[2] * 100, 62)
					end
					q.end_other_pc_block()
				end
				d.setqf2("flame_dungeon", "ticket_delete", 1)
				d.setf("dungeon_enter",1)

				party.setf("dungeon_index", d.get_map_index())
				d.setf("party_leader_pid", party.get_leader_pid())
			end
			if d.getf("level") < 7 then
				if d.getf("clear_count") == 6 then
					d.setf("level",7)
				else
					local rand = number(1,6)
					local setlev = 0
					d.setf("level",7)
					for i=1,50 do
						setlev = setlev + 1
						if setlev > 6 then
							setlev = 1
						end
						if not d.is_unique_dead("door"..setlev) then
							rand = rand - 1
							if rand == 0 then
								d.setf("level",setlev)
								d.setf("clear_count",d.getf("clear_count")+1)
								break
							end
						end
					end
				end
			end
				if d.getf("level") == 1 then
					say(gameforge.flame_dungeon._new_door_open)
					notice_multiline(gameforge.flame_dungeon._demon_start, d.notice)
					d.kill_unique("door1")
					d.kill_unique("idoor1")
					d.setf("level",11)
					local counter_11 = 180
					d.regen_file ("data/dungeon/flame_dungeon/".."fd_a.txt")
				elseif d.getf("level") == 11 then
					say(gameforge.flame_dungeon._kill_all_demon)
				elseif d.getf("level") == 2 then
					say(gameforge.flame_dungeon._new_door_open)
					notice_multiline(gameforge.flame_dungeon._find_item_01, d.notice)
					d.spawn_mob(20386, setting.LEVEL2_STONE_pos[1], setting.LEVEL2_STONE_pos[2])
					d.kill_unique("door2")
					d.kill_unique("idoor2")
					d.set_regen_file ("data/dungeon/flame_dungeon/".."fd_b.txt")
					d.setf("level",12)
				elseif d.getf("level") == 12 then
					say(gameforge.flame_dungeon._find_item_01)
				elseif d.getf("level") == 3 then
					say(gameforge.flame_dungeon._new_door_open)
					notice_multiline(gameforge.flame_dungeon._demon_start, d.notice)
					d.kill_unique("door3")
					d.kill_unique("idoor3")
					d.setf("level",13)
					local counter_13 = 180
					d.regen_file ("data/dungeon/flame_dungeon/".."fd_c.txt")
				elseif d.getf("level") == 13 then
					say(gameforge.flame_dungeon._new_door_open)
				elseif d.getf("level") == 4 then
					say(gameforge.flame_dungeon._new_door_open)
					notice_multiline(gameforge.flame_dungeon._kill_ignator, d.notice)
					d.setf("level",14)
					d.kill_unique("door4")
					d.kill_unique("idoor4")
					d.set_regen_file ("data/dungeon/flame_dungeon/".."fd_d.txt")
					d.spawn_mob(6051,setting.LEVEL4_TARGET_pos[1],setting.LEVEL4_TARGET_pos[2] )
				elseif d.getf("level") == 14 then
					say(gameforge.flame_dungeon._ignator_life)
				elseif d.getf("level") == 5 then
					say(gameforge.flame_dungeon._new_door_open)
					notice_multiline(gameforge.flame_dungeon._find_maat_stone, d.notice)
					d.kill_unique("door5")
					d.kill_unique("idoor5")
					d.setf("level",15)
					d.set_regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					local vis = { 0,0,0,0,0,0,0}
					for i=1,7 do
						vis[i] = 0
					end
					for i = 1, 7 do
						local ran = number(1,7)
						local st = 0
						for j = 1, 50 do
							st = st + 1
							if st > 7 then
								st = 1
							end
							if vis[st] == 0 then
								ran = ran - 1
								if ran == 0 then
									vis[st] = 1
									d.set_unique("stone5_"..st, d.spawn_mob(20386, setting.LEVEL5_STONE_pos[i][1], setting.LEVEL5_STONE_pos[i][2]))
									break
								end
							end
						end
					end
				elseif d.getf("level") == 15 then
					say(gameforge.flame_dungeon._find_maat_stone)
				elseif d.getf("level") == 6 then
					say(gameforge.flame_dungeon._destroy_the_stone)
					notice_multiline(gameforge.flame_dungeon._destroy_the_stone, d.notice)
					d.setf("level",16)
					d.kill_unique("door6")
					d.kill_unique("idoor6")
					d.set_regen_file ("data/dungeon/flame_dungeon/".."fd_f.txt")
					d.spawn_mob(8057, setting.LEVEL6_TARGET_pos[1],setting.LEVEL6_TARGET_pos[2])
				elseif d.getf("level") == 16 then
					say(gameforge.flame_dungeon._stone_not_destroyed)
				elseif d.getf("level") == 7 then
					flame_dungeon.go_boss()
				else
					say()
				end
			npc.unlock()
		end

		when kill with flame_dungeon.is_flamed(pc.get_map_index()) and d.getf("level") == 11 begin
			if d.getf("counter_11") == 0 then
				notice_multiline(gameforge.flame_dungeon._all_demon_killed, d.notice)
				notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
				flame_dungeon.level_clear()
			else
				d.setf("counter_11",d.getf("counter_11")-1)
			end
		end

		when kill with flame_dungeon.is_flamed(pc.get_map_index()) and d.getf("level") == 13 begin
			if d.getf("counter_13") == 0 then
				notice_multiline(gameforge.flame_dungeon._all_demon_killed, d.notice)
				notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
				flame_dungeon.level_clear()
			else
				d.setf("counter_13",d.getf("counter_13")-1)
			end
		end

		when kill with flame_dungeon.is_flamed(pc.get_map_index()) and d.getf("level") == 12 begin
			local i = number(1, 100)
			if i == 1 then
				game.drop_item (30329, 1)
			end
		end

		when 20386.take with flame_dungeon.is_flamed(pc.get_map_index()) and item.vnum == 30329 and d.getf("level") == 12 begin
			local i = number(1, 5)
			if i == 1 then
				npc.purge()
				item.remove()
				notice_multiline(gameforge.flame_dungeon._seal_destroyed, d.notice)
				notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
				flame_dungeon.level_clear()
			else
				item.remove()
				say(gameforge.flame_dungeon._wrong_item)
			end
		end

		when 6051.kill with flame_dungeon.is_flamed(pc.get_map_index()) and d.getf("level") == 14 begin
			notice_multiline(gameforge.flame_dungeon._ignator_dead, d.notice)
			notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
			flame_dungeon.level_clear()
		end

		when kill with flame_dungeon.is_flamed(pc.get_map_index()) and d.getf("level") == 15 begin
			local i = number(1, 30)
			if i == 1 then
				game.drop_item (30330, 1)
			end
		end

		when 20386.take with flame_dungeon.is_flamed(d.get_map_index()) and item.vnum == 30330 and d.getf("level") == 15 begin
			local setting = flame_dungeon.setting()
			if npc.get_vid() == d.get_unique_vid("stone5_1") then
				npc.purge()
				item.remove()
				d.setf("stonekill",2)
				if d.count_monster() < 100 then
					d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
				end
			elseif npc.get_vid() == d.get_unique_vid("stone5_2") then 
				if d.getf("stonekill") == 2 then
					npc.purge()
					item.remove()
					d.setf("stonekill",3)
					if d.count_monster() < 100 then
						d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					end
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			elseif npc.get_vid() == d.get_unique_vid("stone5_3") then
				if d.getf("stonekill") == 3 then
					npc.purge()
					item.remove()
					d.setf("stonekill",4)
					if d.count_monster() < 100 then
						d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					end
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			elseif npc.get_vid() == d.get_unique_vid("stone5_4") then
				if d.getf("stonekill") == 4 then
					npc.purge()
					item.remove()
					d.setf("stonekill",5)
					if d.count_monster() < 100 then
						d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					end
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			elseif npc.get_vid() == d.get_unique_vid("stone5_5") then
				if d.getf("stonekill") == 5 then
					npc.purge()
					item.remove()
					d.setf("stonekill",6)
					if d.count_monster() < 100 then
						d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					end
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			elseif npc.get_vid() == d.get_unique_vid("stone5_6") then
				if d.getf("stonekill") == 6 then
					npc.purge()
					item.remove()
					d.setf("stonekill",7)
					if d.count_monster() < 100 then
						d.regen_file ("data/dungeon/flame_dungeon/".."fd_e.txt")
					end
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			else
				if d.getf("stonekill") == 7 then
					npc.purge()
					item.remove()
					notice_multiline(gameforge.flame_dungeon._all_seal_done, d.notice)
					notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
					flame_dungeon.level_clear()
				else
					item.remove()
					say(gameforge.flame_dungeon._wrong_order)
				end
			end
		end
		
		when 8057.kill with flame_dungeon.is_flamed(d.get_map_index()) and d.getf("level") ==16 begin
			notice_multiline(gameforge.flame_dungeon._stone_destroyed, d.notice)
			notice_multiline(gameforge.flame_dungeon._go_back, d.notice)
			flame_dungeon.level_clear()
		end
		
		when 6091.kill with flame_dungeon.is_flamed(d.get_map_index()) and d.getf("level") ==17 begin
			notice_all("Le groupe de "..pc.get_name().." a vaincu Razador")
			notice_multiline(gameforge.flame_dungeon._razador_death, d.notice)
			notice_multiline(gameforge.flame_dungeon._ending, d.notice)
			timer("exit_dungeon", 60)
			flame_dungeon.level_clear()
			
			if party.is_party() then
				party.setf("flame_dungeon_boss_kill_count", 1)
			end
		end
		
		when exit_dungeon.timer begin
			local setting = flame_dungeon.setting()
			flame_dungeon.clear_timer(d.get_map_index())
			d.set_warp_location(62, setting.outside_entry_pos[1] , setting.outside_entry_pos[2])
			d.exit_all()
			d.setf("party_leader_pid", 0)
		end
	end
end